/*-*- compile-command: "/usr/bin/gcc -c -o cubeprg1.gp.o -O3 -DGCC_INLINE -Wall -fomit-frame-pointer -I/home/goto/usr/include cubeprg1.gp.c && /usr/bin/gcc -o cubeprg1.gp.so -shared -O3 -DGCC_INLINE -Wall -fomit-frame-pointer -Wl,-shared cubeprg1.gp.o -lc -ldl -lm -L/home/goto/usr/lib -lpari-2.2"; -*-*/
#include <pari/pari.h>
/*
GP;install("prmdiv","D0,G,","prmdiv","./cubeprg1.gp.so");
GP;install("modpow","D0,G,D0,G,D0,G,p","modpow","./cubeprg1.gp.so");
GP;install("fngen","D0,G,p","fngen","./cubeprg1.gp.so");
GP;install("check","vD0,G,D0,G,p","check","./cubeprg1.gp.so");
GP;install("init_cubeprg1","v","init_cubeprg1","./cubeprg1.gp.so");
*/
GEN prmdiv(GEN a);
GEN modpow(GEN a, GEN b, GEN p, long prec);
GEN fngen(GEN q, long prec);
void check(GEN f, GEN t, long prec);
void init_cubeprg1(void);
/*End of prototype*/

void
init_cubeprg1(void)	  /* void */
{
  pari_sp ltop = avma;	  /* ulong */
  avma = ltop;
  return;
}

GEN
prmdiv(GEN a)
{
  pari_sp ltop = avma;	  /* ulong */
  GEN p = gzero;
  p = gdeux;
  {
    pari_sp btop = avma;	  /* ulong */
    while (gcmp(p, a) <= 0)
    {
      if (gegalgs(gmod(a, p), 0))
      {
        p = gerepileupto(ltop, p);
        return p;
      }
      p = gnextprime(gaddgs(p, 1));
      p = gerepileupto(btop, p);
    }
  }
  avma = ltop;
  return gzero;
}

GEN
modpow(GEN a, GEN b, GEN p, long prec)
{
  pari_sp ltop = avma;	  /* ulong */
  GEN x = gzero, p1;
  x = gpow(gmodulcp(a, p), b, prec);
  p1 = lift(x);
  p1 = gerepileupto(ltop, p1);
  return p1;
}

GEN
fngen(GEN q, long prec)
{
  pari_sp ltop = avma;	  /* ulong */
  GEN a = gzero, qq = gzero, p = gzero, c = gzero;
  a = gdeux;
  c = gzero;
  {
    pari_sp btop = avma, st_lim = stack_lim(btop, 1);	  /* ulong */
    while (gegalgs(c, 0))
    {
      qq = gsubgs(q, 1);
      c = gun;
      {
        pari_sp btop = avma, st_lim = stack_lim(btop, 1);	  /* ulong */
        while (gcmpgs(qq, 1) > 0)
        {
          p = prmdiv(qq);
          if (gegalgs(modpow(a, gdiv(gsubgs(q, 1), p), q, prec), 1))
            c = gzero;
          {
            pari_sp btop = avma;	  /* ulong */
            while (gegalgs(gmod(qq, p), 0))
            {
              qq = gdiv(qq, p);
              qq = gerepileupto(btop, qq);
            }
          }
          if (low_stack(st_lim, stack_lim(btop, 1)))
            gerepileall(btop, 3, &p, &c, &qq);
        }
      }
      if (gegalgs(c, 0))
        a = gaddgs(a, 1);
      if (low_stack(st_lim, stack_lim(btop, 1)))
        gerepileall(btop, 4, &qq, &c, &p, &a);
    }
  }
  if (gegalgs(modpow(a, gsubgs(q, 1), gsqr(q), prec), 1))
    a = gadd(a, q);
  a = gerepileupto(ltop, a);
  return a;
}

void
check(GEN f, GEN t, long prec)	  /* void */
{
  pari_sp ltop = avma;	  /* ulong */
  GEN a = gzero, g = gzero, q = gzero, r = gzero, p = polx[fetch_user_var("p")], xxx = polx[fetch_user_var("xxx")];
  r = gnextprime(f);
  /*  if(r>t,return("Not a valid interval.")); */
  {
    pari_sp btop = avma, st_lim = stack_lim(btop, 1);	  /* ulong */
    while (gcmp(r, t) <= 0)
    {
      /*    print("Checking for R= ",r); */
      q = gaddgs(gmulsg(2, r), 1);
      {
        pari_sp btop = avma, st_lim = stack_lim(btop, 1);	  /* ulong */
        GEN p1;
        while (gcmp(q, gpowgs(stoi(10), 8)) < 0)
        {
          if (!gcmp0(gisprime(q, 0)))
          {
            g = gmodulcp(fngen(q, prec), gsqr(q));
            a = gpow(g, gdiv(gmul(q, gsubgs(q, 1)), r), prec);
            p = gun;
            p1 = gsubgs(r, 1);
            {
              pari_sp btop = avma, st_lim = stack_lim(btop, 1);	  /* ulong */
              GEN i;
              for (i = gun; gcmp(i, p1) <= 0; i = gaddgs(i, 1))
              {
                p = lift(gmul(p, a));
                if (gcmp(p, sqri(stoi(10))) < 0)
                  write0("mysqrs.txt", coefs_to_vec(5, p, xxx, q, xxx, r));
                else
                  if (((gcmp(p, gpowgs(stoi(10), 8)) < 0) && !gcmp0(gisprime(p, 0))) && gegalgs(modpow(p, r, gpowgs(q, 3), prec), 1))
                    write0("mycubes.txt", coefs_to_vec(5, p, xxx, q, xxx, r));
                if (low_stack(st_lim, stack_lim(btop, 1)))
                  gerepileall(btop, 2, &i, &p);
              }
            }
          }
          /*              print(q,"^3 divides ",p,"^",r,"-1") */
          /*              write("mycubes.txt",q,"^3 divides ",p,"^",r,"-1") */
          q = gadd(q, gmulsg(2, r));
          if (low_stack(st_lim, stack_lim(btop, 1)))
            gerepileall(btop, 5, &g, &a, &p, &p1, &q);
        }
      }
      r = gnextprime(gaddgs(r, 1));
      if (low_stack(st_lim, stack_lim(btop, 1)))
        gerepileall(btop, 5, &q, &g, &a, &p, &r);
    }
  }
  write0("numchkd.txt", coefs_to_vec(3, f, xxx, t));
  avma = ltop;
  return;
}

